/*
 * Copyright (c) 2013, 2018 Oracle and/or its affiliates. All rights reserved.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0, which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the
 * Eclipse Public License v. 2.0 are satisfied: GNU General Public License,
 * version 2 with the GNU Classpath Exception, which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 */

package org.glassfish.admin.rest.testing;

public class BooleanValue extends ScalarValue {
    private boolean value;

    BooleanValue() {
    }

    public boolean getValue() {
        return this.value;
    }

    public BooleanValue value(boolean val) {
        this.value = val;
        regexp(null);
        return this;
    }

    @Override
    Object getJsonValue() throws Exception {
        assertJsonable();
        return (getValue()) ? Boolean.TRUE : Boolean.FALSE;
    }

    @Override
    void print(IndentingStringBuffer sb) {
        sb.println("booleanValue value=" + getValue() + " regexp=" + getRegexp());
    }
}
